Public Class LokalisationsBegriff
    Private m_KoerperRegion As KoerperRegion
    Private m_EBG As Ersatzbegriff
    Private m_ListeAdjektive As New ArrayList
    ReadOnly Property ListeAdjektive() As ArrayList
        Get
            Return m_ListeAdjektive
        End Get
    End Property
    ReadOnly Property KoerperRegion() As KoerperRegion
        Get
            Return m_KoerperRegion
        End Get
    End Property
    Property Ersatzbegriff() As Ersatzbegriff
        Get
            Return m_EBG
        End Get
        Set(ByVal Value As Ersatzbegriff)
            m_EBG = Value
        End Set
    End Property
    Public Sub New(ByVal KoerperRegion As KoerperRegion)
        m_KoerperRegion = KoerperRegion
    End Sub
    Public Function ToFallString(ByVal Fall As Integer) As String
        Dim Pronom As String = Pronom_Liefern(Fall)
        Dim Seitenangabe As String = ""
        If m_KoerperRegion.Seite = Seitenangaben.Links Then
            Dim Adj As New Adjektiv("link")
            Seitenangabe = Adj.ToFallString(Fall, m_EBG.Geschlecht)
        ElseIf m_KoerperRegion.Seite = Seitenangaben.Rechts Then
            Dim Adj As New Adjektiv("recht")
            Seitenangabe = Adj.ToFallString(Fall, m_EBG.Geschlecht)
        ElseIf m_KoerperRegion.Seite = Seitenangaben.Beidseits Then
            Dim Adj As New Adjektiv("beid")
            Seitenangabe = Adj.ToFallString(Fall, m_EBG.Geschlecht)
        End If

        Dim Erg As String = ""
        If Pronom <> "" Then Erg &= Pronom
        If Seitenangabe <> "" Then Erg &= " " & Seitenangabe
        For Each Adj As Adjektiv In m_ListeAdjektive
            Erg &= " " & adj.ToFallString(Fall, m_EBG.Geschlecht)
        Next
        Erg &= " " & m_EBG.ToFallString(Fall)

        Return Erg.Trim
    End Function
    Private Function Pronom_Liefern(ByVal Fall As Integer) As String
        If Fall = -1 Then Return ""

        Select Case m_EBG.Geschlecht
            Case Geschlechter.mnnlich
                Select Case Fall
                    Case 0 : Return "der"
                    Case 1 : Return "des"
                    Case 2 : Return "dem"
                    Case 3 : Return "den"
                    Case 4 : Return "die"
                    Case 5 : Return "der"
                    Case 6 : Return "den"
                    Case 7 : Return "die"
                End Select

            Case Geschlechter.weiblich
                Select Case Fall
                    Case 0 : Return "die"
                    Case 1 : Return "der"
                    Case 2 : Return "der"
                    Case 3 : Return "die"
                    Case 4 : Return "die"
                    Case 5 : Return "der"
                    Case 6 : Return "den"
                    Case 7 : Return "die"
                End Select
            Case Geschlechter.schlich
                Select Case Fall
                    Case 0 : Return "das"
                    Case 1 : Return "des"
                    Case 2 : Return "dem"
                    Case 3 : Return "das"
                    Case 4 : Return "die"
                    Case 5 : Return "der"
                    Case 6 : Return "den"
                    Case 7 : Return "die"
                End Select
        End Select
        Return ""
    End Function
End Class
