Public Class LokalisationsBegriffsEditor

    Private DS As Datensammlung

    Private Initialisierung As Boolean = False

    Private m_AktuellerBegriff As LokalisationsBegriff
    Private m_AktuelleLokalisationsgruppe As Lokalisationsgruppe
    Public Event Beenden()


    Private Sub LokalisationsBegriffsEditor_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        DS = New Datensammlung
    End Sub
    Private Sub MenschControl1_RegionChanged() Handles MenschControl1.SelectedRegionChanged
        Me.ListBoxAlternativen.Items.Clear()
        Me.CheckedListBoxDiffernzierendeAngaben.Items.Clear()
        Me.ListBoxKasus.Items.Clear()
        m_AktuellerBegriff = Nothing
        m_AktuelleLokalisationsgruppe = Nothing

        Dim KR As KoerperRegion = MenschControl1.AktuelleRegion
        If IsNothing(KR) Then Exit Sub

        m_AktuellerBegriff = New LokalisationsBegriff(KR)

        For Each LG As Lokalisationsgruppe In DS.Liste_Lokalisationsgruppen
            If LG.Lokalisation = KR.Lokalisation Then
                m_AktuelleLokalisationsgruppe = LG
                Exit For
            End If
        Next


        If m_AktuellerBegriff.KoerperRegion.Seite = Seitenangaben.Beidseits Then
            For Each EBG As Ersatzbegriff In m_AktuelleLokalisationsgruppe.Ersatzbegriffe
                Me.ListBoxAlternativen.Items.Add(EBG.ToFallString(4))
            Next
        Else
            For Each EBG As Ersatzbegriff In m_AktuelleLokalisationsgruppe.Ersatzbegriffe
                Me.ListBoxAlternativen.Items.Add(EBG.ToFallString(0))
            Next
        End If

        If Me.ListBoxAlternativen.Items.Count > 0 Then
            ListBoxAlternativen.SelectedIndex = 0
        End If
    End Sub
    Private Sub MenschControl1_SeitenModeChanged() Handles MenschControl1.SeitenModeChanged
        Initialisierung = True
        Me.CheckBoxBeidseits.Checked = MenschControl1.SeitenModeBeidseits
        Initialisierung = False
    End Sub

    Private Sub CheckBoxBeidseits_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckBoxBeidseits.CheckedChanged
        If Initialisierung Then Exit Sub
        MenschControl1.SeitenModeBeidseits = Me.CheckBoxBeidseits.Checked
    End Sub

    Private Sub ListBoxAlternativen_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBoxAlternativen.SelectedIndexChanged
        Me.CheckedListBoxDiffernzierendeAngaben.Items.Clear()

        m_AktuellerBegriff.ListeAdjektive.Clear()

        If ListBoxAlternativen.SelectedIndex = -1 Then Exit Sub

        Dim EBG As Ersatzbegriff = m_AktuelleLokalisationsgruppe.Ersatzbegriffe(ListBoxAlternativen.SelectedIndex)
        m_AktuellerBegriff.Ersatzbegriff = EBG

        If m_AktuellerBegriff.KoerperRegion.Seite = Seitenangaben.Beidseits Then
            For Each Adj As Adjektiv In EBG.Adjektive
                Me.CheckedListBoxDiffernzierendeAngaben.Items.Add(Adj.ToFallString(4, EBG.Geschlecht))
            Next
        Else
            For Each Adj As Adjektiv In EBG.Adjektive
                Me.CheckedListBoxDiffernzierendeAngaben.Items.Add(Adj.ToFallString(-1, EBG.Geschlecht))
            Next
        End If

        Werte_anzeigen()
    End Sub

    Private Sub CheckedListBoxDiffernzierendeAngaben_ItemCheck(ByVal sender As Object, ByVal e As System.Windows.Forms.ItemCheckEventArgs) Handles CheckedListBoxDiffernzierendeAngaben.ItemCheck
        If e.NewValue = CheckState.Checked Then
            m_AktuellerBegriff.ListeAdjektive.Add(m_AktuellerBegriff.Ersatzbegriff.Adjektive(e.Index))
        Else
            m_AktuellerBegriff.ListeAdjektive.Remove(m_AktuellerBegriff.Ersatzbegriff.Adjektive(e.Index))
        End If

        Werte_anzeigen()
    End Sub

    Private Sub Werte_anzeigen()
        Me.ListBoxKasus.Items.Clear()
        If m_AktuellerBegriff.KoerperRegion.Seite = Seitenangaben.Beidseits Then
            For I As Integer = 4 To 7
                Me.ListBoxKasus.Items.Add(m_AktuellerBegriff.ToFallString(I))
            Next
        Else
            For I As Integer = 0 To 3
                Me.ListBoxKasus.Items.Add(m_AktuellerBegriff.ToFallString(I))
            Next
        End If

    End Sub

    Private Sub ButtonBeenden_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonBeenden.Click
        RaiseEvent Beenden()
    End Sub
End Class
